#include <stdio.h>

#include <wn/wnargp.h>


bool recover;
char *control_filename,*error_filename,*in_filename,*out_filename;


void main(int argc,char *argv[])
{
  static wn_arg_format arg_format[] =
  {
    WN_KEY_BOOL(&recover,"r"),
    WN_KEY_STRING(&control_filename,"g","control_file",WN_REQUIRED),
    WN_KEY_STRING(&error_filename,"log","error_file",WN_OPTIONAL),
    WN_POS_STRING(&in_filename,"in_file",WN_REQUIRED),
    WN_POS_STRING(&out_filename,"out_file",WN_OPTIONAL),
    WN_ARG_TERMINATE
  };
  
  error_filename = "dastoinf.log";  /* defaults */
  in_filename = "net.inf";
  
  wn_parse_args(argc,argv,arg_format);

  printf("recover = %d\n",recover);
  printf("control filename = <%s>\n",control_filename);
  printf("error_filename = <%s>\n",error_filename);
  printf("in_filename = <%s>\n",in_filename);
  printf("out_filename = <%s>\n",out_filename);
}
  
