#include <stdio.h>
#include <math.h>

#include <wn/wnrndt.h>
#include <wn/wnrnd.h>
#include <wn/wnrndd.h>


#if 1
void main(void)
{
  int bit;

  for(;;)
  {
    /*
    bit = wn_true_random_int();
    */
    bit = wn_true_random_bit();

    printf("%d",bit);
    fflush(stdout);
  }
}
#endif


#if 0
void main(void)
{
  int i,num;

  wn_seed_random_number_generator(1);
  /*
  */

  for(i=0;i<10000000;++i)
  {
    printf("%lf\n ",wn_cauchy_distribution());

    /*
    printf("%d",wn_random_mod_int(6));
    printf("%x\n",num);
    num = wn_random_int();
    num = random();
    printf("%d",wn_random_bit());
    printf("%x\n",wn_random_int());

    printf("%d",wn_random_mod_int(2));
    printf("%lf\n ",wn_normal_distribution());
    printf("%d\n ",wn_poisson_distribution(21));
    printf("%lf\n ",wn_exponential_distribution());
    */
  }
}
#endif


#if 0
void main(void)
{
  register int i;
  register int accum;
  register int *p;
  int num[20];

  accum = 2;
  p = num;

  for(i=0;i<20;++i)
  {
    p[i] = i;
  }

  for(i=0;i<100000000;++i)
  {
    accum += (p[1]&p[3]);
  }
}
#endif


#if 0
#define MAXSHIFT  1000
#define SAMPLE_SIZE 1000000000

/*
#define wn_random_bit()  (random()&1)
*/


local void test_raw_bit(void)
{
  int i,bit;
  int sum;
  double sample_mean,deviation,merit;

  sum = 0;

  for(i=0;i<SAMPLE_SIZE;++i)
  {
    bit = wn_random_bit();

    sum += bit;
  }

  /*
  printf("sum = %d,sample_size = %d\n",sum,SAMPLE_SIZE);
  */

  sample_mean = ((double)sum)/(double)SAMPLE_SIZE;
  deviation = sample_mean-0.5;
  merit = deviation*2.0*sqrt((double)SAMPLE_SIZE);

  /*
  printf("merit = %lf,sample_mean = %lf,deviation = %lf\n",
	 merit,sample_mean,deviation);
  */

  printf("raw bit test:  merit = %lf\n",merit);
}

local void test_for_shift(int shift)
{
  char shift_array[MAXSHIFT];
  int pointer,trail_pointer;
  int i,bit;
  int sum;
  double sample_mean,deviation,merit;

  /*
  printf("shift = %d ---------------------------------------------\n",shift);
  */

  pointer = MAXSHIFT-1;
  trail_pointer = pointer-shift;

  for(i=0;i<shift;++i)
  {
    bit = wn_random_bit();
    shift_array[pointer] = bit;

    ++pointer; if(pointer >= MAXSHIFT) pointer = 0;
    ++trail_pointer; if(trail_pointer >= MAXSHIFT) trail_pointer = 0;
  }

  sum = 0;

  for(i=0;i<SAMPLE_SIZE;++i)
  {
    bit = wn_random_bit();
    shift_array[pointer] = bit;

    sum += (bit^shift_array[trail_pointer]);

    ++pointer; if(pointer >= MAXSHIFT) pointer = 0;
    ++trail_pointer; if(trail_pointer >= MAXSHIFT) trail_pointer = 0;
  }

  /*
  printf("sum = %d,sample_size = %d\n",sum,SAMPLE_SIZE);
  */

  sample_mean = ((double)sum)/(double)SAMPLE_SIZE;
  deviation = sample_mean-0.5;
  merit = deviation*2.0*sqrt((double)SAMPLE_SIZE);

  /*
  printf("merit = %lf,sample_mean = %lf,deviation = %lf\n",
	 merit,sample_mean,deviation);
  */

  printf("shift = %d, merit = %lf\n",shift,merit);
}


void main(void)
{
  int i,shift;

  wn_seed_random_number_generator(0);

  test_raw_bit();

  for(shift=1;shift<MAXSHIFT;++shift)
  {
    test_for_shift(shift);
  }
  /*
  for(shift=32;shift<MAXSHIFT;shift+=32)
  {
    test_for_shift(shift);
  }
  */
}
#endif
