/****************************************************************************

COPYRIGHT NOTICE:

  The source code in this file is provided free of charge
  to the author's consulting clients.  It is in the
  public domain and therefore may be used by anybody for
  any purpose.

AUTHOR:

  Will Naylor

****************************************************************************/
#include <stdio.h>
#include <string.h>

#include <wn/wnlib.h>
#include <wn/wnmem.h>
#include <wn/wnsll.h>
#include <wn/wncmp.h>
#include <wn/wnrndd.h>

#include <wn/wnsort.h>



#if 1
local char string_index(string,index)

char string[];
int index;

{
  return(string[index]);
}


main()
{
  char string_index();
  char *string;
  wn_sll list,el;

  wn_gpmake("no_free");
  wn_gplabel("main group");

  list = NULL;
  
  wn_sllins(&list,"foo");
  wn_sllins(&list,"bar");
  wn_sllins(&list,"tim");
  wn_sllins(&list,"mouse");
  wn_sllins(&list,"ant");
  wn_sllins(&list,"turkey");

  wn_sort_sll(&list,(int (*)(ptr,ptr))(strcmp));
  /*
  wn_radix_sort_sll(&list,(string_index),(strlen));
  */

  for(el=list;el!=NULL;el=el->next)
  {
    string = (char *)(el->contents);

    printf("%s\n",string);
  }
}
#endif



#if 0
local char int_index(int *pint,int index)
{
  return(((char *)pint)[index]);
}


local int int_len(int *pint)
{
  return(sizeof(int));
}


local int pintcmp(int *pi1,int *pi2)
{
  return(wn_intcmp(*pi1,*pi2));
}


void main(void)
{
  int i,r,*r_copy;
  wn_sll list,el;

  wn_gpmake("no_free");
  wn_gplabel("main group");

  list = NULL;
  
  printf("start\n");
  for(i=0;i<5000000;i++)
  {
    r = wn_random_int_between(0,1000000);
   
    r_copy = wn_alloc(sizeof(int));
    *r_copy = r;
    wn_sllins(&list,(ptr)r_copy);
  }

  printf("start sort\n");
  /*
  wn_radix_sort_sll(&list,(int_index),(int_len));
  */
  wn_sort_sll(&list,(int (*)(ptr,ptr))(pintcmp));
  printf("finish sort\n");

  /*
  for(el=list;el!=NULL;el=el->next)
  {
    r_copy = el->contents;

    printf("%d\n",*r_copy);
  }
  */
}
#endif



